Kubernetes
Kubernetes is a container orchestration system for automating, managing and scaling software deployment. Managed Kubernetes allows you to easily create Kubernetes clusters without having to take care about low level details.
List clusters
Returns a list of Kubernetes clusters.
List clusters › Responses
200 getClusters response
List of Kubernetes clusters
name^[a-z0-9]([-a-z0-9]*… · requiredName
networkNetwork UUID
zoneUpCloud zone to provision the Kubernetes cluster in
versionKubernetes version identifier
labelscontrol_plane_ip_filterList of IP blocks
network_cidrCIDR of the given network
storage_encryptionThe storage encryption strategy.
List of node groups
stateCluster operational state
uuidUUID
planCluster plan
private_node_groupsEnable private node groups
List of OIDC issuers and their claim validation rules.
Create cluster
Creates a new Kubernetes cluster.
Create cluster › Request Body
name^[a-z0-9]([-a-z0-9]*… · requiredName
networkNetwork UUID
zoneUpCloud zone to provision the Kubernetes cluster in
versionKubernetes version identifier
labelscontrol_plane_ip_filterList of IP blocks
network_cidrCIDR of the given network
storage_encryptionThe storage encryption strategy.
List of node groups
stateCluster operational state
uuidUUID
planCluster plan
private_node_groupsEnable private node groups
List of OIDC issuers and their claim validation rules.
Create cluster › Responses
201 postCluster response
name^[a-z0-9]([-a-z0-9]*… · requiredName
networkNetwork UUID
zoneUpCloud zone to provision the Kubernetes cluster in
versionKubernetes version identifier
labelscontrol_plane_ip_filterList of IP blocks
network_cidrCIDR of the given network
storage_encryptionThe storage encryption strategy.
List of node groups
stateCluster operational state
uuidUUID
planCluster plan
private_node_groupsEnable private node groups
List of OIDC issuers and their claim validation rules.
Get cluster details
Returns Kubernetes cluster details by given uuid.
path Parameters
uuidUUID
UUID
Get cluster details › Responses
200 getCluster response
name^[a-z0-9]([-a-z0-9]*… · requiredName
networkNetwork UUID
zoneUpCloud zone to provision the Kubernetes cluster in
versionKubernetes version identifier
labelscontrol_plane_ip_filterList of IP blocks
network_cidrCIDR of the given network
storage_encryptionThe storage encryption strategy.
List of node groups
stateCluster operational state
uuidUUID
planCluster plan
private_node_groupsEnable private node groups
List of OIDC issuers and their claim validation rules.
Delete cluster
Deletes an existing Kubernetes cluster by given uuid.
path Parameters
uuidUUID
UUID
Delete cluster › Responses
Modify cluster
Modifies an existing Kubernetes cluster by given {uuid}.
path Parameters
uuidUUID
UUID
Modify cluster › Request Body
labelscontrol_plane_ip_filterList of IP blocks
planCluster plan
Modify cluster › Responses
202 patchCluster response
name^[a-z0-9]([-a-z0-9]*… · requiredName
networkNetwork UUID
zoneUpCloud zone to provision the Kubernetes cluster in
versionKubernetes version identifier
labelscontrol_plane_ip_filterList of IP blocks
network_cidrCIDR of the given network
storage_encryptionThe storage encryption strategy.
List of node groups
stateCluster operational state
uuidUUID
planCluster plan
private_node_groupsEnable private node groups
List of OIDC issuers and their claim validation rules.
Get kubeconfig
Returns kubeconfig for Kubernetes cluster by given {uuid}.
path Parameters
uuidUUID
UUID
Get kubeconfig › Responses
200 getClusterKubeconfig response
kubeconfigKubeconfig
Get available upgrades
Returns a list of available versions that can be used to upgrade the cluster.
path Parameters
uuidUUID
UUID
Get available upgrades › Responses
200 upgrades response
versionsUpgrade cluster
Upgrades an existing Kubernetes cluster to specific version.
path Parameters
uuidUUID
UUID
Upgrade cluster › Request Body
versionKubernetes version identifier
upgrade strategy for node group upgrades
Upgrade cluster › Responses
200 upgrades response
versionKubernetes version identifier
upgrade strategy for node group upgrades
List node groups
Returns a list of available node groups of an existing Kubernetes cluster. Cluster is identified by given {uuid}.
A node group is a uniform set of worker nodes attached to a cluster.
path Parameters
uuidUUID
UUID
List node groups › Responses
200 getNodeGroups response
List of node groups
countAmount of nodes in a node group
name^[a-z0-9]([-a-z0-9]*… · requiredName
planNode group plan
List of Kubelet arguments
List of labels
Node group custom plan properties
Node group cloud native plan properties
Node group GPU plan properties
ssh_keysList of public SSH keys
stateNode group operational state
storageStorage UUID to use as a template
storage_encryptionThe storage encryption strategy.
List of taints
anti_affinityEnable anti-affinity policies
utility_network_accessEnable utility network access
node_updatesEnable periodic package updates on node
Create node group
Creates a new node group to an existing Kubernetes cluster. Cluster is identified by given {uuid}.
path Parameters
uuidUUID
UUID
Create node group › Request Body
countAmount of nodes in a node group
name^[a-z0-9]([-a-z0-9]*… · requiredName
planNode group plan
List of Kubelet arguments
List of labels
Node group custom plan properties
Node group cloud native plan properties
Node group GPU plan properties
ssh_keysList of public SSH keys
stateNode group operational state
storageStorage UUID to use as a template
storage_encryptionThe storage encryption strategy.
List of taints
anti_affinityEnable anti-affinity policies
utility_network_accessEnable utility network access
node_updatesEnable periodic package updates on node
Create node group › Responses
201 postNodeGroup response
countAmount of nodes in a node group
name^[a-z0-9]([-a-z0-9]*… · requiredName
planNode group plan
List of Kubelet arguments
List of labels
Node group custom plan properties
Node group cloud native plan properties
Node group GPU plan properties
ssh_keysList of public SSH keys
stateNode group operational state
storageStorage UUID to use as a template
storage_encryptionThe storage encryption strategy.
List of taints
anti_affinityEnable anti-affinity policies
utility_network_accessEnable utility network access
node_updatesEnable periodic package updates on node
Get node group details
Returns node group details by given {node_group_name}. Cluster is identified by given {uuid}.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Get node group details › Responses
200 getNodeGroupDetails response
name^[a-z0-9]([-a-z0-9]*… · requiredName
countAmount of nodes in a node group
planNode group plan
List of node group nodes (experimental)
List of Kubelet arguments
List of labels
Node group custom plan properties
Node group cloud native plan properties
Node group GPU plan properties
ssh_keysList of public SSH keys
stateNode group operational state
storageStorage UUID to use as a template
storage_encryptionThe storage encryption strategy.
List of taints
anti_affinityEnable anti-affinity policies
utility_network_accessEnable utility network access
node_updatesEnable periodic package updates on node
Delete node group
Deletes an existing node group by given Kubernetes cluster {uuid} and {node_group_name}.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Delete node group › Responses
Modify node group
Modifies an existing node group of a cluster. Cluster is identified by given {uuid} and node group by {node_group_name}.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Modify node group › Request Body
countAmount of nodes in a node group
Modify node group › Responses
200 patchNodeGroup response
countAmount of nodes in a node group
name^[a-z0-9]([-a-z0-9]*… · requiredName
planNode group plan
List of Kubelet arguments
List of labels
Node group custom plan properties
Node group cloud native plan properties
Node group GPU plan properties
ssh_keysList of public SSH keys
stateNode group operational state
storageStorage UUID to use as a template
storage_encryptionThe storage encryption strategy.
List of taints
anti_affinityEnable anti-affinity policies
utility_network_accessEnable utility network access
node_updatesEnable periodic package updates on node
Delete node group node
Deletes a node group node from a cluster (experimental). Cluster is identified by given {uuid}, node group by {name}, and node by {node-name}.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
node-name^[a-z0-9]([-a-z0-9]*… · requiredNode name
Node name
Delete node group node › Responses
List plans
Returns a list of available Kubernetes cluster plans.
List plans › Responses
200 getPlans response
List of plans
descriptionPlan description
name^[a-z0-9]([-a-z0-9]*… · requiredName
List versions
Returns a list of available Kubernetes cluster versions.
List versions › Responses
200 getVersions response
List of Kubernetes versions
idKubernetes version identifier
versionKubernetes semantic version
List cluster authentication entries
Returns all OIDC authentication issuer configurations for a cluster.
path Parameters
uuidUUID
UUID
List cluster authentication entries › Responses
List of authentication entries.
List of OIDC issuers and their claim validation rules.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Replace the full cluster authentication configuration
Replaces the entire set of OIDC authentication issuer configurations for a cluster with the supplied JSON list of issuers. The full set is validated before being applied. An empty list clears all issuers.
path Parameters
uuidUUID
UUID
Replace the full cluster authentication configuration › Request Body
List of OIDC issuers and their claim validation rules.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Replace the full cluster authentication configuration › Responses
Authentication configuration replaced.
List of OIDC issuers and their claim validation rules.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Create a cluster authentication entry
Creates a new OIDC authentication issuer configuration. The new entry is validated together with the cluster's existing entries before being applied. Fails if an entry with the same name already exists.
path Parameters
uuidUUID
UUID
Create a cluster authentication entry › Request Body
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Create a cluster authentication entry › Responses
Authentication entry created.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Import a full cluster authentication configuration
Replaces the entire set of OIDC authentication issuer configurations for a cluster with the supplied native kube-apiserver v1 AuthenticationConfiguration YAML document. Issuers are named deterministically from their issuer URL host. The top-level anonymous field is not supported and any configuration that would drop data is rejected.
path Parameters
uuidUUID
UUID
Import a full cluster authentication configuration › Request Body
kube-apiserver v1 AuthenticationConfiguration YAML document
Import a full cluster authentication configuration › Responses
Authentication configuration imported.
List of OIDC issuers and their claim validation rules.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Get a cluster authentication entry
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Get a cluster authentication entry › Responses
Authentication entry details.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Update a cluster authentication entry
Updates an existing OIDC authentication issuer configuration. The name in the path is authoritative. The updated entry is validated together with the cluster's other entries before being applied.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Update a cluster authentication entry › Request Body
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Update a cluster authentication entry › Responses
Authentication entry updated.
name^[a-z0-9]([-a-z0-9]*… · requiredName
issuer_urlaudiencesAccepted audiences for tokens from this issuer. The first audience is used as the OIDC client id in generated kubeconfigs by default; the OIDC kubeconfig endpoint's audience query parameter can select a different one.
discovery_urlaudience_match_policycertificate_authorityBase64-encoded PEM certificate authority bundle.
Rules for mapping token claims to Kubernetes user attributes.
Delete a cluster authentication entry
Removes an OIDC authentication issuer configuration by name.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
Delete a cluster authentication entry › Responses
Authentication entry deleted.
Get OIDC kubeconfig
Returns a kubeconfig for the cluster whose user authenticates via the kubelogin (kubectl oidc-login) exec credential plugin, using the cluster's configured OIDC issuer identified by the name path parameter. The plugin (kubelogin) must be installed on the client. No long-lived credential is embedded. The OIDC client secret and any provider-specific kubelogin flags are not injected by the server; the returned kubeconfig includes comments describing how to add them.
path Parameters
uuidUUID
UUID
name^[a-z0-9]([-a-z0-9]*… · requiredName
Name
query Parameters
audienceWhich of the issuer's configured audiences to use as the OIDC client id in the generated kubeconfig. When omitted, the issuer's first audience is used. Must match one of the issuer's audiences.
Get OIDC kubeconfig › Responses
200 getClusterKubeconfig response
kubeconfigKubeconfig